"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// Packages
const Sentry = __importStar(require("@sentry/node"));
// Ours
const logger_1 = __importDefault(require("../logger"));
const config_1 = require("../config");
const log = (0, logger_1.default)('socket-api');
function default_1(socket, next) {
    try {
        log.trace('New socket connection: ID %s with IP %s', socket.id, socket.handshake.address);
        socket.on('error', (err) => {
            if (config_1.sentryEnabled) {
                Sentry.captureException(err);
            }
            log.error(err);
        });
        socket.on('message', (data) => {
            log.trace('Received message %s (sent to bundle %s) with data:', data.messageName, data.bundleName, data.content);
            socket.broadcast.emit('message', data);
        });
        socket.on('joinRoom', (room, cb) => __awaiter(this, void 0, void 0, function* () {
            if (typeof room !== 'string') {
                cb('Room must be a string', undefined);
                return;
            }
            if (!Object.keys(socket.rooms).includes(room)) {
                log.trace('Socket %s joined room:', socket.id, room);
                yield socket.join(room);
            }
            cb(undefined, undefined);
        }));
        next();
    }
    catch (error) {
        next(error);
    }
}
exports.default = default_1;
//# sourceMappingURL=socketApiMiddleware.js.map